VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtTip 
      Height          =   375
      Left            =   960
      TabIndex        =   3
      Text            =   "Hello, from the tray"
      Top             =   2040
      Width           =   2895
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete the Icon"
      Height          =   495
      Left            =   1680
      TabIndex        =   2
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton cmdModify 
      Caption         =   "Modify the Icon"
      Height          =   495
      Left            =   1680
      TabIndex        =   1
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "Add the Icon"
      Height          =   495
      Left            =   1680
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
    
Private Type NOTIFYICONDATA
    cbSize As Long
    hWnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Private Const NIM_ADD = 0
Private Const NIM_MODIFY = 1
Private Const NIM_DELETE = 2
Private Const NIF_MESSAGE = 1
Private Const NIF_ICON = 2
Private Const NIF_TIP = 4

Private Declare Function Shell_NotifyIconA Lib "SHELL32" _
    (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Integer

Private Function setNOTIFYICONDATA(hWnd As Long, ID As Long, _
    Flags As Long, CallbackMessage As Long, Icon As Long, _
    Tip As String) As NOTIFYICONDATA
    
    Dim nidTemp As NOTIFYICONDATA
    
    nidTemp.cbSize = Len(nidTemp)
    nidTemp.hWnd = hWnd
    nidTemp.uID = ID
    nidTemp.uFlags = Flags
    nidTemp.uCallbackMessage = CallbackMessage
    nidTemp.hIcon = Icon
    nidTemp.szTip = Tip & Chr$(0)
    
    setNOTIFYICONDATA = nidTemp
End Function

Private Sub cmdAdd_Click()
    ' This will add the Form1 icon to the system tray
    
    Dim retVal As Integer
    Dim nid As NOTIFYICONDATA
    
    ' This creates our NotifyIconData variable
    nid = setNOTIFYICONDATA( _
        Form1.hWnd, vbNull, _
        NIF_MESSAGE Or NIF_ICON Or NIF_TIP, _
        vbNull, Form1.Icon, txtTip)
    
    ' Now we call our API with this variable
    retVal = Shell_NotifyIconA(NIM_ADD, nid)
End Sub

Private Sub cmdModify_Click()
    ' This will modify an existing tray icon
    
    Dim retVal As Integer
    Dim nid As NOTIFYICONDATA
    
    nid = setNOTIFYICONDATA( _
        Form1.hWnd, vbNull, _
        NIF_MESSAGE Or NIF_ICON Or NIF_TIP, _
        vbNull, Form1.Icon, txtTip)
    
    retVal = Shell_NotifyIconA(NIM_MODIFY, nid)
End Sub

Private Sub cmdDelete_Click()
    ' This will delete an existing tray icon
    
    Dim retVal As Integer
    Dim nid As NOTIFYICONDATA
    
    nid = setNOTIFYICONDATA( _
        Form1.hWnd, vbNull, _
        NIF_MESSAGE Or NIF_ICON Or NIF_TIP, _
        vbNull, Form1.Icon, txtTip)
    
    retVal = Shell_NotifyIconA(NIM_DELETE, nid)
End Sub
